ompi/mca/ptl/mx/ptl_mx_recvfrag.h File Reference.TH "ompi/mca/ptl/mx/ptl_mx_recvfrag.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/ptl/mx/ptl_mx_recvfrag.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ptl_mx.h'\fP
.br
\fC#include 'mca/ptl/base/ptl_base_recvfrag.h'\fP
.br
\fC#include 'ptl_mx_sendfrag.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PTL_MX_RECV_FRAG_ALLOC\fP(frag, rc)"
.br
.ti -1c
.RI "#define \fBMCA_PTL_MX_RECV_FRAG_RETURN\fP(frag)"
.br
.ti -1c
.RI "#define \fBMCA_PTL_MX_RECV_FRAG_MATCH\fP(frag, hdr)"
.br
.RI "\fICallback on receipt of a match fragment. \fP"
.ti -1c
.RI "#define \fBMCA_PTL_MX_RECV_FRAG_RNDV\fP(frag, hdr)"
.br
.RI "\fICallback on receipt of a rendezvous fragment. \fP"
.ti -1c
.RI "#define \fBMCA_PTL_MX_RECV_FRAG_FRAG\fP(frag)"
.br
.RI "\fIProcess a fragment that completed. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_ptl_mx_recv_frag_t\fP \fBmca_ptl_mx_recv_frag_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBmca_ptl_mx_recv_frag_t\fP)"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define MCA_PTL_MX_RECV_FRAG_ALLOC(frag, rc)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    opal_list_item_t* item; \
    OMPI_FREE_LIST_GET(&mca_ptl_mx_component.mx_recv_frags, item, rc); \
    frag = (mca_ptl_mx_recv_frag_t*)item; \
    }
.fi
.SS "#define MCA_PTL_MX_RECV_FRAG_FRAG(frag)"
.PP
\fBValue:\fP
.PP
.nf
do { \
    /* copy into user space */ \
    if(frag->frag_recv.frag_is_buffered) { \
        struct iovec iov; \
        uint32_t iov_count; \
        size_t max_data; \
        int32_t free_after; \
  \
        iov.iov_base = frag->frag_recv.frag_base.frag_addr; \
        iov.iov_len = frag->frag_recv.frag_base.frag_size; \
        iov_count = 1; \
        max_data = iov.iov_len; \
        ompi_convertor_unpack( &frag->frag_recv.frag_base.frag_convertor, \
                               &iov, &iov_count, &max_data, &free_after ); \
        frag->frag_recv.frag_base.frag_size = max_data; \
    } \
 \
    /* progress the request */ \
    frag->frag_recv.frag_base.frag_owner->ptl_recv_progress( \
        frag->frag_recv.frag_base.frag_owner, \
        frag->frag_recv.frag_request, \
        frag->frag_size, \
        frag->frag_recv.frag_base.frag_size); \
 \
    MCA_PTL_MX_RECV_FRAG_RETURN(frag); \
} while(0)
.fi
Process a fragment that completed. 
.PP
.SS "#define MCA_PTL_MX_RECV_FRAG_MATCH(frag, hdr)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                       \
    if(hdr->hdr_common.hdr_flags & MCA_PTL_FLAGS_NBO) {                    \
         MCA_PTL_BASE_MATCH_HDR_NTOH(hdr->hdr_match);                      \
    }                                                                      \
    ptl->super.ptl_match(&ptl->super, &frag->frag_recv, &hdr->hdr_match);  \
} while(0)
.fi
Callback on receipt of a match fragment. 
.PP
.SS "#define MCA_PTL_MX_RECV_FRAG_RETURN(frag)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    if(frag->frag_recv.frag_is_buffered && \
       frag->frag_data != frag->frag_recv.frag_base.frag_addr) { \
        free(frag->frag_recv.frag_base.frag_addr); \
    } \
    OMPI_FREE_LIST_RETURN(&mca_ptl_mx_component.mx_recv_frags, (opal_list_item_t*)frag); \
}
.fi
.SS "#define MCA_PTL_MX_RECV_FRAG_RNDV(frag, hdr)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                       \
    if(hdr->hdr_common.hdr_flags & MCA_PTL_FLAGS_NBO) {                    \
         MCA_PTL_BASE_RNDV_HDR_NTOH(hdr->hdr_rndv);                        \
    }                                                                      \
    ptl->super.ptl_match(&ptl->super, &frag->frag_recv, &hdr->hdr_match);  \
} while(0)
.fi
Callback on receipt of a rendezvous fragment. 
.PP
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
